
#include "stdafx.h"
#include <Windows.h>
#include <stdlib.h>
#include <stdio.h>
#include "ktextfile.h"

KTEXTFILE::KTEXTFILE(){
	f=0;
	pBaseMem=0;
	pCurrentPointer=0;
	LastError=0;
	BufferSize=0;
	dwLineNum=0;
}

KTEXTFILE::~KTEXTFILE(){
	if(pBaseMem!=0) free(pBaseMem);
}

int KTEXTFILE::Init(char *szFileName){
	dwLineNum=0;

	f=fopen(szFileName, "rb");
	if(f==0) return 0;//File open error

	fseek(f, 0, SEEK_END);
	BufferSize=ftell(f);
	fseek(f, 0, SEEK_SET);
	if(BufferSize==0)
		return 0;

	pBaseMem=(char*)calloc(BufferSize+1, 1);
	if(pBaseMem==0){
		fclose(f);
		return 0;
	}
	pCurrentPointer=pBaseMem;
	//Read file to buffer
	fread(pBaseMem, 1, BufferSize, f);
	fclose(f);
	return 1;
}

int KTEXTFILE::IsEOLcharA(char c){
	if(c==0 || c==0xD || c==0xA) return 1;
	return 0;
}

//skip spaces tabs CR CL
int KTEXTFILE::IsWhiteSpaceA(char c){
	if(c==0 || c==0xD || c==0xA || c==0x20 || c==0x9) return 1;
	return 0;
}

//Return pointer to next line in buffer
char *KTEXTFILE::ReadLineA(){
	char *p=0, *pRet=0;

	//Skip whitespaces
	int fBufferEndReached=0;
	for(p=pCurrentPointer; p<(pBaseMem+BufferSize); p++){
		if(IsWhiteSpaceA(*p) == 0){fBufferEndReached=1; break;}
	}
	if(!fBufferEndReached) return 0;//End of buffer
	pRet=p;

	//Search EOL
	fBufferEndReached=0;
	for(p=pRet; p<(pBaseMem+BufferSize); p++){
		if(IsEOLcharA(*p) != 0){fBufferEndReached=1; break;}
	}
	pCurrentPointer=p;

	DWORD Len = (DWORD)p - (DWORD)pRet;
	char* pStr = (char*)calloc(Len + 1, 1);
	memcpy(pStr, pRet, Len);
	return pStr;
}

int KTEXTFILE::ReadLineA(char *buf, long len){
	char *p=0, *pRet=0;
	len--;
	//Skip whitespaces
	int fBufferEndReached=0;
	for(p=pCurrentPointer; p<(pBaseMem+BufferSize); p++){
		if(IsWhiteSpaceA(*p) == 0){fBufferEndReached=1; break;}
	}
	if(!fBufferEndReached) return 0;//End of buffer
	pRet=p;

	//Search EOL
	for(p=pRet; p<(pBaseMem+BufferSize); p++){
		if(IsEOLcharA(*p)==0 && len--!=0){
			*buf++=*p;//copy src to dst
			*buf=0;
		}
		else{
			break;
		}
	}
	pCurrentPointer=p;
	return 1;
}
